// -------------------------------------------------------------
// ϊɂcD[
// 
// Copyright (c) 2003 IMAGIRE Takashi. All rights reserved.
// -------------------------------------------------------------

// -------------------------------------------------------------
// O[oϐ
// -------------------------------------------------------------
float4x4 mWVP;
float4 LightPos;
float4 EyePos;
float4 vColor;

// -------------------------------------------------------------
// eNX`
// -------------------------------------------------------------
// ͗l̃eNX`
texture DecaleTex;
sampler DecaleSamp = sampler_state
{
    Texture = <DecaleTex>;
    MinFilter = LINEAR;
    MagFilter = LINEAR;
    MipFilter = NONE;

    AddressU = Clamp;
    AddressV = Clamp;
};
// -------------------------------------------------------------
// cD[̃eNX`
texture ToonTex;
sampler ToonSamp = sampler_state
{
    Texture = <ToonTex>;
    MinFilter = LINEAR;
    MagFilter = LINEAR;
    MipFilter = NONE;

    AddressU = Clamp;
    AddressV = Clamp;
};
// -------------------------------------------------------------
// AvP[V璸_VF[_ɓnf[^
// -------------------------------------------------------------
struct VS_INPUT
{
    float4 Pos          : POSITION;
    float3 Normal       : NORMAL0;
    float2 Tex			: TEXCOORD0;	// fJ[eNX`W
};
// -------------------------------------------------------------
// _VF[_sNZVF[_ɓnf[^
// -------------------------------------------------------------
struct VS_OUTPUT
{
    float4 Pos          : POSITION;
    float2 Tex			: TEXCOORD0;	// fJ[eNX`W
    float2 ToonCoord    : TEXCOORD1;	// gD[p
};

// -------------------------------------------------------------
// Wϊ
// -------------------------------------------------------------
float2 Q(float3 In, float3 B, float3 T, float3 N)
{
	float2 Out = (float2)0;
	
	// \ʍWn֕ϊ
	float3 v;
	v.x = dot(B,In);
	v.y = dot(T,In);
	v.z = dot(N,In);

	float pv = 7.0f/8.0f;
	float ar = 1.0/(2.0*(1.000000001+v.z));

	Out.x = pv * ar * v.x + 0.5;
	Out.y = pv * ar * v.y + 0.5;

	return Out;
}
// -------------------------------------------------------------
// _VF[_vO
// -------------------------------------------------------------
VS_OUTPUT VS(VS_INPUT In)
{   
	VS_OUTPUT Out = (VS_OUTPUT)0;			 // o̓f[^
	
	// ʒuW
	Out.Pos = mul( In.Pos, mWVP );
	
	// \ʍWn̊xNg߂
	float3 N = In.Normal;					// @xNg
	float3 B = float3(0,1,0);				// ]@xNg
	float3 T = normalize(cross(N,B));		// ڃxNg
	B = cross(T,N);
	
	// xNgeNX`W֕ϊ
	float3 L = normalize(LightPos-In.Pos.xyz);// CgxNg
	Out.ToonCoord = Q(L, B,T,N);
	
	// fJ[̃eNX`W
	Out.Tex = In.Tex;

    return Out;
}
// -------------------------------------------------------------
// sNZVF[_vO
// -------------------------------------------------------------
float4 PS(VS_OUTPUT In) : COLOR
{   
    float4 decale = tex2D( DecaleSamp, In.Tex );	  // fJ[
    float  shade  = tex2D( ToonSamp,   In.ToonCoord );// cD[
	
    return (0.5f*shade+0.5f) * decale;
}
// -------------------------------------------------------------
// eNjbN
// -------------------------------------------------------------
technique TShader
{
    pass P0
    {
        VertexShader = compile vs_1_1 VS();
        PixelShader  = compile ps_1_1 PS();
    }
}

